<?php
  session_start();
  $_SESSION["username"] = "temp";
  $_SESSION["password"] = "temp";
  include_once "./audiostreamerlib.php";

  //  AudioStreamer, www.audiostreamer.org
  //  Copyright (C) <2013>  <Lieven Rottiers>
  //
  //  This program is free software: you can redistribute it and/or modify
  //  it under the terms of the GNU General Public License as published by
  //  the Free Software Foundation, either version 3 of the License, or
  //  (at your option) any later version.
  //
  //  This program is distributed in the hope that it will be useful,
  //  but WITHOUT ANY WARRANTY; without even the implied warranty of
  //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  //  GNU General Public License for more details.
  //
  //  You should have received a copy of the GNU General Public License
  //  along with this program.  If not, see <http://www.gnu.org/licenses/>.


  //no time limit
  set_time_limit(0);
  
  try {
    global $sdb;
    $dbh = new PDO("sqlite:".$sdb);
    $dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);

    //check provided credentials 
    $username = isset($_GET["username"]) ? $_GET["username"] : null;
    $password = isset($_GET["password"]) ? $_GET["password"] : null;
    $error = null;
    if (empty($username)) { 
      $error = 'User must be specified.'; 
    } else if (empty($password)) { 
      $error = 'Password must be specified.'; 
    } else {
      $db_password = '';
      $sql = "select id, name, password from user where name='".$username."'";
      foreach ($dbh->query($sql) as $row) {
        $db_password = $row["password"];
      }   
      if ($password!=$db_password) { 
        $error = 'Wrong login credentials.'; 
      }
    }
    if (! empty($error) ) {
      //wrong or no login credentials, log error
      $dbh->beginTransaction();
      $sql =  
          "insert into log(user, event, date, ip, path)
           values ('".$username."', 'ERROR', '".date('Y/m/d H:i:s')."', '".$_SERVER['REMOTE_ADDR']."', 'StreamRadio Error: ".$error."')";
      $dbh->exec($sql);
      //keep only the 2000 most recent records    
      $sql = "delete from log where id not in (select id from log order by id desc limit 2000)";
      $dbh->exec($sql);
      $dbh->commit();         
      //
      //session_destroy(); 
      exit($error);
    }
            
    //output the headers
    header("Accept-Ranges: none");
    header("Content-Type: audio/mpeg");
    header("Cache-Control: no-cache");
    header('Pragma: no-cache');

    //start loop
    $looped = 0;
    while(1) {
      $looped = $looped + 1;
      // Did the connection fail?
      //if (connection_status() != CONNECTION_NORMAL) {
      //  break;
      //}
      
      //fetching setting parameters
      $sql = "select param, value from param";
      foreach ($dbh->query($sql) as $row) {
        $_SESSION[$row["param"]] = $row["value"];
      }   

      //radio stream works only when resampling
      //$resampling = $_SESSION["ind_resampling"];
      $resampling = 1;
      $bitrate = $_SESSION["bitrate"];
      //normalizing is done when resampling
      //$normalizing = $_SESSION["ind_normalizing"];
      $normalizing = '1';
      $http_range = isset($_SERVER['HTTP_RANGE']) ? $_SERVER['HTTP_RANGE'] : '';
      $file = '';
      $extension = '';
      $artist = '';
      $album = '';
      $song = '';
      $cmd = '';

      //fetch next radio song
      $sql = "select b.id,
                     b.path, b.length_seconds, 
                     ifnull(nullif(b.song_gain,''), '-6.00 dB') as song_gain, 
                     ifnull(nullif(b.album_gain,''), '-6.00 dB') as album_gain,
                     b.extension,
                     b.artist, b.album, b.song
              from music b
              where 1=1 
             ";

      if (strpos(",".$_SESSION["genre_radio"]."," , ",ALL,") === false){
        //one of the chosen genres
        $sql = $sql."  and b.genre in (select x.genre from genre x where x.id in (".str_replace("CURRENT,","",$_SESSION["genre_radio"]).")) ";
      }

      if ($_SESSION["last_days_radio"] ==! "") {
        //restrict to songs added/changed within the last ... days
        $sql = $sql."
                  and b.file_modified >= '".date('Y/m/d H:i:s', (strtotime("-".$_SESSION["last_days_radio"]." day")) )."' ";
      }
             
      $sql = $sql."
                and ifnull(b.extension,'dir') in (".$audioformats.")
              order by random()||b.id
              limit 1";
      
      foreach ($dbh->query($sql) as $row) {
        $id = $row['id'];
        $file = $row['path'];
        $extension = $row['extension'];
        $artist = $row['artist'];
        $album = $row['album'];
        $song = $row['song'];
      }   
      
      //send icy headers
      //header('ICY 200 OK');
      //header('icy-notice1:<BR>This stream requires <a href="http://www.winamp.com/">Winamp</a><BR>');
      //header('icy-notice2:SHOUTcast Distributed Network Audio Server/Linux v1.9.8<BR>');
      //header('icy-name:HarderBeatz.de');
      //header('icy-genre:HandsUp, Dance, House, Trance, and More');
      //header('icy-url:http://harderbeatz.de/');
      //header('icy-pub:1');
      //header("icy-name:".$artist." - ".$album." - ".$song);
      //header("x-audiocast-name:".$artist." - ".$album." - ".$song);

      //insert a record in the log table
      $dbh->beginTransaction();
      $sql =  
          "insert into log(user, event, date, ip, http_range, path, album_artist, artist, album, song, extension)
           select '".$username."', 'STREAM', '".date('Y/m/d H:i:s')."', '".$_SERVER['REMOTE_ADDR']."', '".$http_range."', path, album_artist, artist, album, song, extension
           from music
           where id = ".$id;
      $dbh->exec($sql);
      //keep only the 2000 most recent records    
      $sql = "delete from log where id not in (select id from log order by id desc limit 2000)";
      $dbh->exec($sql);
      $dbh->commit();   
      
      //close connection
      //$dbh = null;
      
      //stream the file
      if (!file_exists($file)) {
        //error wegschrijven      
        $dbh->beginTransaction();
        $sql =  
            "insert into log(user, event, date, ip, path)
             values ('".$username."', 'ERROR', '".date('Y/m/d H:i:s')."', '".$_SERVER['REMOTE_ADDR']."', 'StreamRadio Error: File \"".$file."\" does not exist')";
        $dbh->exec($sql);
        //keep only the 2000 most recent records    
        $sql = "delete from log where id not in (select id from log order by id desc limit 2000)";
        $dbh->exec($sql);
        $dbh->commit();         
      }
      if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {    
        //We are on Windows
        $windows = '1';
      } else {
        $windows = '0';
      }
    
      if ($resampling == '1') {
        if ($windows == '1') {    
          //Windows
          //if ffmpeg.exe or lame.exe file not exists in root directory then no resampling
          //change relative path to absolute path
          $ffmpeg = "../ffmpeg.exe";
          $lame = "../lame.exe";
          $ffmpeg = realpath($ffmpeg);
          $lame = realpath($lame);
          //
          if ((!file_exists($ffmpeg)) || (!file_exists($lame))) {
            $resampling = '0';
          }
          //enclose the paths by quotes (in case path contains spaces...)
          $ffmpeg = "\"".$ffmpeg."\"";
          $lame = "\"".$lame."\"";
          //
        } else {
          //Linux
          //if ffmpeg or lame are not found on system then no resampling
          $ffmpeg = trim(shell_exec('which ffmpeg'));
          $lame = trim(shell_exec('which lame'));
          if ((empty($ffmpeg)) || (empty($lame))) {
            $resampling = '0';
          }
          $ffmpeg = "ffmpeg";
          $lame = "lame";                
        }
      }

      if ($resampling != '1') {
        //error wegschrijven
        $dbh->beginTransaction();
        $sql =  
            "insert into log(user, event, date, ip, path)
             values ('".$username."', 'ERROR', '".date('Y/m/d H:i:s')."', '".$_SERVER['REMOTE_ADDR']."', 'StreamRadio Error: ffmpeg and/or lame are not found on system')";
        $dbh->exec($sql);
        //keep only the 2000 most recent records    
        $sql = "delete from log where id not in (select id from log order by id desc limit 2000)";
        $dbh->exec($sql);
        $dbh->commit();         
      }
      //resample the file and read back the results
      //-vol makes adjustment to volume, 256 means no change in volume
      if ($normalizing == '1') {
        //calculate gain percentage
        //
        //if no gain is found in database then the default is -6db
        $gain = str_ireplace([" dB","dB"],"",$row['song_gain']);
      }
      else {
        $gain = 0;
      }

      //flag -re means to "Read input at native frame rate"
      //$cmd = $ffmpeg." -re -i \"".$file."\" -vol ".round(256*$gain)." -f wav - | ".$lame." -b ".$bitrate." --noreplaygain - -";
      $cmd = $ffmpeg." -re -i \"".$file."\" -af \"volume=".$gain."dB\" -f wav - | ".$lame." -b ".$bitrate." --noreplaygain - -";

      ob_clean();
      flush();

      passthru($cmd);

    }
    //end loop
    
  }
  catch(PDOException $e)
  {
    echo '<br/>'.$e->getMessage();
  }  
 
?>
